diff -ruN qmail-1.03-orig/smtpcall.c qmail-1.03-ldap-20060201-orig/smtpcall.c
--- qmail-1.03-orig/smtpcall.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/smtpcall.c	2006-02-25 11:00:56.000000000 +0100
@@ -0,0 +1,274 @@
+/*
+ * Copyright (c) 2003-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#include <unistd.h>
+#include "auto_qmail.h"
+#include "coe.h"
+#include "fd.h"
+#include "substdio.h"
+#include "str.h"
+#include "stralloc.h"
+#include "timeoutread.h"
+#include "timeoutwrite.h"
+#include "wait.h"
+
+#include "smtpcall.h"
+
+int call_getln(substdio *ss, stralloc *l)
+{
+  int i;
+  if (!stralloc_copys(l, "")) return -1;
+  for (;;) {
+    if (!stralloc_readyplus(l,1)) return -1;
+    i = substdio_get(ss, l->s + l->len, 1);
+    if (i != 1) return i;
+    if (l->s[l->len] == '\n') break;
+    ++l->len;
+  }
+  if (l->len > 0) if (l->s[l->len-1] == '\r') --l->len;
+  l->s[l->len] = 0;
+  return l->len;
+}
+
+int
+call_getc(struct call *cc, char *c)
+{
+	int r;
+	if (cc->flagerr || cc->flagabort) return -1;
+	r = substdio_get(&cc->ssfrom, c, 1);
+	if (r == -1) {
+		cc->flagerr = 1;
+		return -1;
+	}
+	return r;
+}
+
+int
+call_put(struct call *cc, const char *s, unsigned int len)
+{
+	if (cc->flagerr || cc->flagabort) return -1;
+	if (cc->flagstar && str_diffn(s, "*", len) == 0) {
+		cc->flagabort = 1;
+		return -1;
+	}
+	if (substdio_put(&cc->ssto, s, len) == -1) {
+		cc->flagerr = 1;
+		return -1;
+	}
+	return 0;
+}
+
+int
+call_puts(struct call *cc, const char *s)
+{
+	if (cc->flagerr || cc->flagabort) return -1;
+	if (cc->flagstar && str_diff(s, "*") == 0) {
+		cc->flagabort = 1;
+		return -1;
+	}
+	if (substdio_puts(&cc->ssto, s) == -1) {
+		cc->flagerr = 1;
+		return -1;
+	}
+	return 0;
+}
+
+int
+call_flush(struct call *cc)
+{
+	if (cc->flagerr || cc->flagabort) return -1;
+	if (substdio_flush(&cc->ssto) == -1) {
+		cc->flagerr = 1;
+		return -1;
+	}
+	return 0;
+
+}
+
+int
+call_putflush(struct call *cc, const char *s, unsigned int len)
+{
+	if (call_put(cc, s, len) == -1) return -1;
+        if (call_flush(cc) == -1) return -1;
+	return 0;
+}
+
+int
+call_putsflush(struct call *cc, const char *s)
+{
+	if (call_puts(cc, s) == -1) return -1;
+        if (call_flush(cc) == -1) return -1;
+	return 0;
+}
+
+static int mytimeout = 10;
+
+static int
+mywrite(int fd, void *buf, int len)
+{
+	return timeoutwrite(mytimeout,fd,buf,len);
+}
+
+static int
+myread(int fd, void *buf, int len)
+{
+	return timeoutread(mytimeout,fd,buf,len);
+}
+
+int
+call_open(struct call *cc, const char *prog, int timeout, int flagstar)
+{
+  int pit[2];
+  int pif[2];
+  const char *(args[2]);
+
+  args[0] = prog;
+  args[1] = 0;
+
+  if (pipe(pit) == -1) return -1;
+  if (pipe(pif) == -1) { close(pit[0]); close(pit[1]); return -1; }
+ 
+  switch(cc->pid = vfork()) {
+    case -1:
+      close(pit[0]); close(pit[1]);
+      close(pif[0]); close(pif[1]);
+      return -1;
+    case 0:
+      close(pit[1]);
+      close(pif[0]);
+      if (fd_move(0,pit[0]) == -1) _exit(120);
+      if (fd_move(1,pif[1]) == -1) _exit(120);
+      if (chdir(auto_qmail) == -1) _exit(61);
+      execv(*args,(char **)args);
+      _exit(120);
+  }
+
+  if (timeout != 0) mytimeout = timeout;
+  cc->flagerr = 0;
+  cc->flagabort = 0;
+  cc->flagstar = flagstar;
+  cc->tofd = pit[1]; close(pit[0]);
+  cc->fromfd = pif[0]; close(pif[1]);
+  coe(cc->tofd); coe(cc->fromfd);
+  substdio_fdbuf(&cc->ssto, mywrite, cc->tofd,
+      cc->tobuf, sizeof(cc->tobuf));
+  substdio_fdbuf(&cc->ssfrom, myread, cc->fromfd,
+      cc->frombuf, sizeof(cc->frombuf));
+  return 0;
+}
+
+void
+call_close(struct call *cc)
+{
+	int wstat;
+	int r;
+	char ch;
+	
+	if ((long)cc->pid == -1) return; /* nothing running */
+	call_flush(cc);
+	close(cc->tofd);
+	while ((r = call_getc(cc, &ch)) == 1) ;
+	if (r == -1) ; /* bad thing happend but who cares */
+	close(cc->fromfd);
+      
+	wait_pid(&wstat,cc->pid); /* just kill the zombie */
+}
+
+const char *
+auth_close(struct call *cc, stralloc *user, const char *pre)
+{
+	const char *s;
+	int wstat;
+	int exitcode;
+	char c;
+
+	s = 0; c = 0;
+	if ((long)cc->pid == -1)
+		return "454 unable to start authentication process. "
+		    "(#4.3.0)\r\n";
+	
+	if (cc->flagabort)
+		s = "501 authentication exchange aborted. (#4.3.0)\r\n";
+	if (cc->flagerr)
+		s = "454 authentication process write failure. (#4.3.0)\r\n";
+	
+	if (!cc->flagerr && !cc->flagabort) {
+		if (call_getc(cc, &c) == -1) {
+			s = "454 authentication process read failure. "
+			    "(#4.3.0)\r\n";
+		} else
+		switch (c) {
+		case 'K':
+			if (!stralloc_copys(user, pre!=0?pre:"")) {
+				s = "421 out of memory (#4.3.0)\r\n"; 
+				break;
+			}
+			while (call_getc(cc, &c) == 1) {
+				if (!stralloc_append(user, &c)) {
+					s = "421 out of memory (#4.3.0)\r\n"; 
+					break;
+				}
+			}
+			if (cc->flagerr)
+				s = "454 authentication process read "
+				    "failure. (#4.3.0)\r\n";
+			else
+				s = "235 nice to meet you\r\n";
+			break;
+		case 'D':
+			s = "535 authentication failure\r\n";
+			break;
+		case 'Z':
+			s = "501 authentication exchange failed\r\n";
+			break;
+		default:
+			s = "454 authentication process failure. (#4.3.0)\r\n";
+			break;
+		}
+	}
+	close(cc->tofd);
+	close(cc->fromfd);
+      
+	if ((unsigned long)wait_pid(&wstat,cc->pid) != cc->pid)
+		return "454 authentication waitpid surprise (#4.3.0)\r\n";
+	if (wait_crashed(wstat))
+		return "454 authentication process crashed (#4.3.0)\r\n";
+	exitcode = wait_exitcode(wstat);
+	switch (exitcode) {
+	case 0:
+		return s;
+	default:
+		return "454 temporary authentication failure (#4.3.0)\r\n";
+	}
+}
+
diff -ruN qmail-1.03-orig/smtpcall.h qmail-1.03-ldap-20060201-orig/smtpcall.h
--- qmail-1.03-orig/smtpcall.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/smtpcall.h	2006-02-25 11:00:56.000000000 +0100
@@ -0,0 +1,65 @@
+/*
+ * Copyright (c) 2003-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#ifndef __SMTPCALL_H__
+#define __SMTPCALL_H__
+
+#include "stralloc.h"
+#include "substdio.h"
+
+struct call {
+  int flagerr;
+  int flagabort;
+  int flagstar;
+  unsigned long pid;
+  int tofd;
+  int fromfd;
+  substdio ssto;
+  substdio ssfrom;
+  char tobuf[256];
+  char frombuf[128];
+} ;
+
+int call_getln(substdio *, stralloc *);
+int call_getc(struct call *, char *);
+int call_put(struct call *, const char *, unsigned int);
+int call_puts(struct call *, const char *);
+int call_flush(struct call *);
+int call_putflush(struct call *, const char *, unsigned int);
+int call_putsflush(struct call *, const char *);
+int call_open(struct call *, const char *, int, int);
+void call_close(struct call *);
+
+const char *auth_close(struct call *, stralloc *, const char *);
+
+#endif
diff -ruN qmail-1.03-orig/spawn.c qmail-1.03-ldap-20060201-orig/spawn.c
--- qmail-1.03-orig/spawn.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/spawn.c	2006-02-25 11:00:56.000000000 +0100
@@ -1,5 +1,8 @@
 #include <sys/types.h>
 #include <sys/stat.h>
+#include <unistd.h>
+#include "readwrite.h"
+#include "alloc.h"
 #include "sig.h"
 #include "wait.h"
 #include "substdio.h"
@@ -15,11 +18,13 @@
 #include "auto_uids.h"
 #include "auto_spawn.h"
 
-extern int truncreport;
+extern unsigned int truncreport;
 extern int spawn();
 extern void report();
 extern void initialize();
 
+int flagreinit = 0;
+
 struct delivery
  {
   int used;
@@ -28,6 +33,9 @@
   int wstat; /* if !pid: status of child */
   int fdout; /* pipe output, -1 if !pid; delays eof until after death */
   stralloc output;
+#ifdef DEBUG
+  stralloc log;
+#endif
  }
 ;
 
@@ -37,7 +45,7 @@
 {
  int wstat;
  int pid;
- int i;
+ unsigned int i;
  while ((pid = wait_nohang(&wstat)) > 0)
    for (i = 0;i < auto_spawn;++i) if (d[i].used)
      if (d[i].pid == pid)
@@ -63,30 +71,44 @@
 int flagreading = 1;
 char outbuf[1024]; substdio ssout;
 
-int stage = 0; /* reading 0:delnum 1:messid 2:sender 3:recip */
+int stage = 0; /* reading 0:delnum 1:delnum2 2:messid 3:sender 4:recip */
 int flagabort = 0; /* if 1, everything except delnum is garbage */
-int delnum;
+unsigned int delnum;
 stralloc messid = {0};
 stralloc sender = {0};
 stralloc recip = {0};
 
 void err(s) char *s;
 {
- char ch; ch = delnum; substdio_put(&ssout,&ch,1);
+ unsigned char ch;
+ ch = delnum; substdio_put(&ssout,&ch,1);
+ ch = delnum >> 8; substdio_put(&ssout,&ch,1);
  substdio_puts(&ssout,s); substdio_putflush(&ssout,"",1);
 }
 
 void docmd()
 {
  int f;
- int i;
- int j;
+ unsigned int i;
+ unsigned int j;
  int fdmess;
  int pi[2];
  struct stat st;
 
+ /* SIGHUP HANDLING */
+ if (delnum == 0xbeef)
+   if (*messid.s == '\0' && *sender.s == '\0' && *recip.s == '\0') {
+#if 0
+     err("HHUP received\n");
+#endif
+     flagreinit = 1;
+     return;
+   }
+ 
  if (flagabort) { err("Zqmail-spawn out of memory. (#4.3.0)\n"); return; }
+#if 0 /* no longer possible, delnum is unsigned */
  if (delnum < 0) { err("ZInternal error: delnum negative. (#4.3.5)\n"); return; }
+#endif
  if (delnum >= auto_spawn) { err("ZInternal error: delnum too big. (#4.3.5)\n"); return; }
  if (d[delnum].used) { err("ZInternal error: delnum in use. (#4.3.5)\n"); return; }
  for (i = 0;i < messid.len;++i)
@@ -136,7 +158,7 @@
 {
  int i;
  int r;
- char ch;
+ unsigned char ch;
 
  r = read(0,cmdbuf,sizeof(cmdbuf));
  if (r == 0)
@@ -154,17 +176,20 @@
    switch(stage)
     {
      case 0:
-       delnum = (unsigned int) (unsigned char) ch;
-       messid.len = 0; stage = 1; break;
+       delnum = ch;
+       stage = 1; break;
      case 1:
+       delnum += (unsigned int)ch << 8;
+       messid.len = 0; stage = 2; break;
+     case 2:
        if (!stralloc_append(&messid,&ch)) flagabort = 1;
        if (ch) break;
-       sender.len = 0; stage = 2; break;
-     case 2:
+       sender.len = 0; stage = 3; break;
+     case 3:
        if (!stralloc_append(&sender,&ch)) flagabort = 1;
        if (ch) break;
-       recip.len = 0; stage = 3; break;
-     case 3:
+       recip.len = 0; stage = 4; break;
+     case 4:
        if (!stralloc_append(&recip,&ch)) flagabort = 1;
        if (ch) break;
        docmd();
@@ -175,12 +200,12 @@
 
 char inbuf[128];
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
- char ch;
- int i;
+ unsigned char ch;
+ unsigned int i;
  int r;
  fd_set rfds;
  int nfds;
@@ -201,12 +226,23 @@
 
  initialize(argc,argv);
 
- ch = auto_spawn; substdio_putflush(&ssout,&ch,1);
+ ch = auto_spawn; substdio_put(&ssout,&ch,1);
+ ch = auto_spawn >> 8; substdio_putflush(&ssout,&ch,1);
 
- for (i = 0;i < auto_spawn;++i) { d[i].used = 0; d[i].output.s = 0; }
+ for (i = 0;i < auto_spawn;++i) {
+   d[i].used = 0;
+   d[i].output.s = 0;
+#ifdef DEBUG
+   d[i].log.s = 0;
+#endif
+ }
 
  for (;;)
   {
+   if (flagreinit) {
+     initialize(argc,argv);
+     flagreinit = 0;
+   }
    if (!flagreading)
     {
      for (i = 0;i < auto_spawn;++i) if (d[i].used) break;
@@ -236,24 +272,87 @@
 	   continue; /* read error on a readable pipe? be serious */
 	 if (r == 0)
 	  {
-           ch = i; substdio_put(&ssout,&ch,1);
+	   unsigned char c; c = i; substdio_put(&ssout,&c,1);
+	   c = i >> 8; substdio_put(&ssout,&c,1);
 	   report(&ssout,d[i].wstat,d[i].output.s,d[i].output.len);
 	   substdio_put(&ssout,"",1);
 	   substdio_flush(&ssout);
 	   close(d[i].fdin); d[i].used = 0;
 	   continue;
 	  }
+#ifdef DEBUG
+#	 define IS_LOG(x) ( d[(x)].used & 0x8 )
+#	 define LOGON(x)  ( d[(x)].used |= 0x8 )
+#	 define LOGOFF(x) ( d[(x)].used = 1 )
+	 {
+	  unsigned int j;
+	  unsigned int b;
+	  unsigned int t;
+	  for (j=0, b=0; j < (unsigned int)r; j++) {
+	    if (inbuf[j] == 15) {
+	      while (!stralloc_readyplus(&d[i].output,j-b)) sleep(10); /*XXX*/
+	      byte_copy(d[i].output.s + d[i].output.len,j-b,inbuf+b);
+	      d[i].output.len += j-b;
+	      LOGON(i);
+	      b = j+1;
+	    } else if ( inbuf[j] == 16 ) {
+	      while (!stralloc_readyplus(&d[i].log,j-b)) sleep(10); /*XXX*/
+	      byte_copy(d[i].log.s + d[i].log.len,j-b,inbuf+b);
+	      d[i].log.len += j-b;
+	      b = j+1;
+	      LOGOFF(i);
+	      if (truncreport > 100)
+		if (d[i].log.len > truncreport) {
+		  const char *truncmess = "\nError report too long, sorry.\n";
+		  d[i].log.len = truncreport - str_len(truncmess) - 3;
+		  stralloc_cats(&d[i].log,truncmess);
+		}
+	      ch = i; substdio_put(&ssout,&ch,1);
+	      ch = i >> 8; substdio_put(&ssout,&ch,1);
+	      ch = 'L'; substdio_put(&ssout,&ch,1);
+	      for (t = 0;t < d[i].log.len; ++t) if (!d[i].log.s[t]) break;
+	      substdio_put(&ssout,d[i].log.s,t);
+	      substdio_put(&ssout,"",1);
+	      substdio_flush(&ssout);
+	      d[i].log.len = 0;
+	    }
+	  }
+	  if (b == (unsigned int)r) continue;
+	  if ( IS_LOG(i) )
+	   {
+	    while (!stralloc_readyplus(&d[i].log,r-b)) sleep(10); /*XXX*/
+	    byte_copy(d[i].log.s + d[i].log.len,r-b,inbuf+b);
+	    d[i].log.len += r-b;
+	   }
+	  else
+	   {
+	    while (!stralloc_readyplus(&d[i].output,r-b)) sleep(10); /*XXX*/
+	    byte_copy(d[i].output.s + d[i].output.len,r-b,inbuf+b);
+	    d[i].output.len += r-b;
+	    if (truncreport > 100)
+	      if (d[i].output.len > truncreport)
+	       {
+		const char *truncmess = "\nError report too long, sorry.\n";
+		d[i].output.len = truncreport - str_len(truncmess) - 3;
+		stralloc_cats(&d[i].output,truncmess);
+	       }
+	   }
+	 }
+#else
 	 while (!stralloc_readyplus(&d[i].output,r)) sleep(10); /*XXX*/
 	 byte_copy(d[i].output.s + d[i].output.len,r,inbuf);
 	 d[i].output.len += r;
 	 if (truncreport > 100)
 	   if (d[i].output.len > truncreport)
 	    {
-	     char *truncmess = "\nError report too long, sorry.\n";
+	     const char *truncmess = "\nError report too long, sorry.\n";
 	     d[i].output.len = truncreport - str_len(truncmess) - 3;
 	     stralloc_cats(&d[i].output,truncmess);
 	    }
+#endif
 	}
     }
   }
+ /* NOTREACHED */
+ return 0;
 }
diff -ruN qmail-1.03-orig/splogger.c qmail-1.03-ldap-20060201-orig/splogger.c
--- qmail-1.03-orig/splogger.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/splogger.c	2006-02-25 11:00:56.000000000 +0100
@@ -10,7 +10,7 @@
 #include "fmt.h"
 
 char buf[800]; /* syslog truncates long lines (or crashes); GPACIC */
-int bufpos = 0; /* 0 <= bufpos < sizeof(buf) */
+unsigned int bufpos = 0; /* 0 <= bufpos < sizeof(buf) */
 int flagcont = 0;
 int priority; /* defined if flagcont */
 char stamp[FMT_ULONG + FMT_ULONG + 3]; /* defined if flagcont */
@@ -45,7 +45,7 @@
   bufpos = 0;
 }
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -69,4 +69,6 @@
     if ((ch < 32) || (ch > 126)) ch = '?'; /* logger truncates at 0; GPACIC */
     buf[bufpos++] = ch;
   }
+  /* NOTREACHED */
+  return 0;
 }
diff -ruN qmail-1.03-orig/stralloc_arts.c qmail-1.03-ldap-20060201-orig/stralloc_arts.c
--- qmail-1.03-orig/stralloc_arts.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/stralloc_arts.c	2006-02-25 11:00:56.000000000 +0100
@@ -4,9 +4,9 @@
 
 int stralloc_starts(sa,s)
 stralloc *sa;
-char *s;
+const char *s;
 {
-  int len;
+  unsigned int len;
   len = str_len(s);
   return (sa->len >= len) && byte_equal(s,len,sa->s);
 }
diff -ruN qmail-1.03-orig/stralloc_catb.c qmail-1.03-ldap-20060201-orig/stralloc_catb.c
--- qmail-1.03-orig/stralloc_catb.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/stralloc_catb.c	2006-02-25 11:00:56.000000000 +0100
@@ -3,7 +3,7 @@
 
 int stralloc_catb(sa,s,n)
 stralloc *sa;
-char *s;
+const char *s;
 unsigned int n;
 {
   if (!sa->s) return stralloc_copyb(sa,s,n);
diff -ruN qmail-1.03-orig/stralloc_cats.c qmail-1.03-ldap-20060201-orig/stralloc_cats.c
--- qmail-1.03-orig/stralloc_cats.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/stralloc_cats.c	2006-02-25 11:00:56.000000000 +0100
@@ -4,7 +4,7 @@
 
 int stralloc_cats(sa,s)
 stralloc *sa;
-char *s;
+const char *s;
 {
   return stralloc_catb(sa,s,str_len(s));
 }
diff -ruN qmail-1.03-orig/stralloc.h qmail-1.03-ldap-20060201-orig/stralloc.h
--- qmail-1.03-orig/stralloc.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/stralloc.h	2006-02-25 11:00:56.000000000 +0100
@@ -5,16 +5,16 @@
 
 GEN_ALLOC_typedef(stralloc,char,s,len,a)
 
-extern int stralloc_ready();
-extern int stralloc_readyplus();
-extern int stralloc_copy();
-extern int stralloc_cat();
-extern int stralloc_copys();
-extern int stralloc_cats();
-extern int stralloc_copyb();
-extern int stralloc_catb();
-extern int stralloc_append(); /* beware: this takes a pointer to 1 char */
-extern int stralloc_starts();
+extern int stralloc_ready(stralloc *, unsigned int);
+extern int stralloc_readyplus(stralloc *, unsigned int);
+extern int stralloc_copy(stralloc *, stralloc *);
+extern int stralloc_cat(stralloc *, stralloc *);
+extern int stralloc_copys(stralloc *, const char *);
+extern int stralloc_cats(stralloc *, const char *);
+extern int stralloc_copyb(stralloc *, const char *, unsigned int);
+extern int stralloc_catb(stralloc *, const char *, unsigned int);
+extern int stralloc_append(stralloc *, const char *); /* beware: this takes a pointer to 1 char */
+extern int stralloc_starts(stralloc *, const char *);
 
 #define stralloc_0(sa) stralloc_append(sa,"")
 
diff -ruN qmail-1.03-orig/stralloc_opyb.c qmail-1.03-ldap-20060201-orig/stralloc_opyb.c
--- qmail-1.03-orig/stralloc_opyb.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/stralloc_opyb.c	2006-02-25 11:00:56.000000000 +0100
@@ -3,7 +3,7 @@
 
 int stralloc_copyb(sa,s,n)
 stralloc *sa;
-char *s;
+const char *s;
 unsigned int n;
 {
   if (!stralloc_ready(sa,n + 1)) return 0;
diff -ruN qmail-1.03-orig/stralloc_opys.c qmail-1.03-ldap-20060201-orig/stralloc_opys.c
--- qmail-1.03-orig/stralloc_opys.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/stralloc_opys.c	2006-02-25 11:00:56.000000000 +0100
@@ -4,7 +4,7 @@
 
 int stralloc_copys(sa,s)
 stralloc *sa;
-char *s;
+const char *s;
 {
   return stralloc_copyb(sa,s,str_len(s));
 }
diff -ruN qmail-1.03-orig/stralloc_pend.c qmail-1.03-ldap-20060201-orig/stralloc_pend.c
--- qmail-1.03-orig/stralloc_pend.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/stralloc_pend.c	2006-02-25 11:00:56.000000000 +0100
@@ -2,4 +2,4 @@
 #include "stralloc.h"
 #include "gen_allocdefs.h"
 
-GEN_ALLOC_append(stralloc,char,s,len,a,i,n,x,30,stralloc_readyplus,stralloc_append)
+GEN_ALLOC_append(stralloc,const char,s,len,a,i,n,x,30,stralloc_readyplus,stralloc_append)
diff -ruN qmail-1.03-orig/str_chr.c qmail-1.03-ldap-20060201-orig/str_chr.c
--- qmail-1.03-orig/str_chr.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/str_chr.c	2006-02-25 11:00:56.000000000 +0100
@@ -1,11 +1,11 @@
 #include "str.h"
 
 unsigned int str_chr(s,c)
-register char *s;
+register const char *s;
 int c;
 {
   register char ch;
-  register char *t;
+  register const char *t;
 
   ch = c;
   t = s;
diff -ruN qmail-1.03-orig/str_cpy.c qmail-1.03-ldap-20060201-orig/str_cpy.c
--- qmail-1.03-orig/str_cpy.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/str_cpy.c	2006-02-25 11:00:56.000000000 +0100
@@ -2,9 +2,9 @@
 
 unsigned int str_copy(s,t)
 register char *s;
-register char *t;
+register const char *t;
 {
-  register int len;
+  register unsigned int len;
 
   len = 0;
   for (;;) {
diff -ruN qmail-1.03-orig/str_diff.c qmail-1.03-ldap-20060201-orig/str_diff.c
--- qmail-1.03-orig/str_diff.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/str_diff.c	2006-02-25 11:00:56.000000000 +0100
@@ -1,8 +1,8 @@
 #include "str.h"
 
 int str_diff(s,t)
-register char *s;
-register char *t;
+register const char *s;
+register const char *t;
 {
   register char x;
 
diff -ruN qmail-1.03-orig/str_diffn.c qmail-1.03-ldap-20060201-orig/str_diffn.c
--- qmail-1.03-orig/str_diffn.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/str_diffn.c	2006-02-25 11:00:56.000000000 +0100
@@ -1,8 +1,8 @@
 #include "str.h"
 
 int str_diffn(s,t,len)
-register char *s;
-register char *t;
+register const char *s;
+register const char *t;
 unsigned int len;
 {
   register char x;
diff -ruN qmail-1.03-orig/strerr_die.c qmail-1.03-ldap-20060201-orig/strerr_die.c
--- qmail-1.03-orig/strerr_die.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/strerr_die.c	2006-02-25 11:00:56.000000000 +0100
@@ -4,7 +4,8 @@
 #include "strerr.h"
 
 void strerr_warn(x1,x2,x3,x4,x5,x6,se)
-char *x1; char *x2; char *x3; char *x4; char *x5; char *x6;
+const char *x1; const char *x2; const char *x3;
+const char *x4; const char *x5; const char *x6;
 struct strerr *se;
 {
   strerr_sysinit();
@@ -29,7 +30,8 @@
 
 void strerr_die(e,x1,x2,x3,x4,x5,x6,se)
 int e;
-char *x1; char *x2; char *x3; char *x4; char *x5; char *x6;
+const char *x1; const char *x2; const char *x3;
+const char *x4; const char *x5; const char *x6;
 struct strerr *se;
 {
   strerr_warn(x1,x2,x3,x4,x5,x6,se);
diff -ruN qmail-1.03-orig/strerr.h qmail-1.03-ldap-20060201-orig/strerr.h
--- qmail-1.03-orig/strerr.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/strerr.h	2006-02-25 11:00:56.000000000 +0100
@@ -4,18 +4,22 @@
 struct strerr
  {
   struct strerr *who;
-  char *x;
-  char *y;
-  char *z;
+  const char *x;
+  const char *y;
+  const char *z;
  }
 ;
 
 extern struct strerr strerr_sys;
-extern void strerr_sysinit();
+extern void strerr_sysinit(void);
 
+/* XXX not available in qmail-1.03
 extern char *strerr();
-extern void strerr_warn();
-extern void strerr_die();
+*/
+extern void strerr_warn(const char *, const char *, const char *,
+    const char *, const char *, const char *, struct strerr *);
+extern void strerr_die(int, const char *, const char *, const char *,
+    const char *, const char *, const char *, struct strerr *);
 
 #define STRERR(r,se,a) \
 { se.who = 0; se.x = a; se.y = 0; se.z = 0; return r; }
diff -ruN qmail-1.03-orig/strerr_sys.c qmail-1.03-ldap-20060201-orig/strerr_sys.c
--- qmail-1.03-orig/strerr_sys.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/strerr_sys.c	2006-02-25 11:00:56.000000000 +0100
@@ -3,7 +3,7 @@
 
 struct strerr strerr_sys;
 
-void strerr_sysinit()
+void strerr_sysinit(void)
 {
   strerr_sys.who = 0;
   strerr_sys.x = error_str(errno);
diff -ruN qmail-1.03-orig/str.h qmail-1.03-ldap-20060201-orig/str.h
--- qmail-1.03-orig/str.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/str.h	2006-02-25 11:00:56.000000000 +0100
@@ -1,13 +1,13 @@
 #ifndef STR_H
 #define STR_H
 
-extern unsigned int str_copy();
-extern int str_diff();
-extern int str_diffn();
-extern unsigned int str_len();
-extern unsigned int str_chr();
-extern unsigned int str_rchr();
-extern int str_start();
+extern unsigned int str_copy(char *, const char *);
+extern int str_diff(const char *, const char *);
+extern int str_diffn(const char *, const char *, unsigned int);
+extern unsigned int str_len(const char *);
+extern unsigned int str_chr(const char *, int);
+extern unsigned int str_rchr(const char *, int);
+extern int str_start(const char *, const char *);
 
 #define str_equal(s,t) (!str_diff((s),(t)))
 
diff -ruN qmail-1.03-orig/str_len.c qmail-1.03-ldap-20060201-orig/str_len.c
--- qmail-1.03-orig/str_len.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/str_len.c	2006-02-25 11:00:56.000000000 +0100
@@ -1,9 +1,9 @@
 #include "str.h"
 
 unsigned int str_len(s)
-register char *s;
+register const char *s;
 {
-  register char *t;
+  register const char *t;
 
   t = s;
   for (;;) {
diff -ruN qmail-1.03-orig/str_rchr.c qmail-1.03-ldap-20060201-orig/str_rchr.c
--- qmail-1.03-orig/str_rchr.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/str_rchr.c	2006-02-25 11:00:56.000000000 +0100
@@ -1,12 +1,12 @@
 #include "str.h"
 
 unsigned int str_rchr(s,c)
-register char *s;
+register const char *s;
 int c;
 {
   register char ch;
-  register char *t;
-  register char *u;
+  register const char *t;
+  register const char *u;
 
   ch = c;
   t = s;
diff -ruN qmail-1.03-orig/str_start.c qmail-1.03-ldap-20060201-orig/str_start.c
--- qmail-1.03-orig/str_start.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/str_start.c	2006-02-25 11:00:56.000000000 +0100
@@ -1,8 +1,8 @@
 #include "str.h"
 
 int str_start(s,t)
-register char *s;
-register char *t;
+register const char *s;
+register const char *t;
 {
   register char x;
 
diff -ruN qmail-1.03-orig/subfderr.c qmail-1.03-ldap-20060201-orig/subfderr.c
--- qmail-1.03-orig/subfderr.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/subfderr.c	2006-02-25 11:00:56.000000000 +0100
@@ -3,5 +3,5 @@
 #include "subfd.h"
 
 char subfd_errbuf[256];
-static substdio it = SUBSTDIO_FDBUF(write,2,subfd_errbuf,256);
+static substdio it = SUBSTDIO_FDBUF(subwrite,2,subfd_errbuf,256);
 substdio *subfderr = &it;
diff -ruN qmail-1.03-orig/subfd.h qmail-1.03-ldap-20060201-orig/subfd.h
--- qmail-1.03-orig/subfd.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/subfd.h	2006-02-25 11:00:56.000000000 +0100
@@ -9,7 +9,7 @@
 extern substdio *subfdoutsmall;
 extern substdio *subfderr;
 
-extern int subfd_read();
-extern int subfd_readsmall();
+extern int subfd_read(int, void *, int);
+extern int subfd_readsmall(int, void *, int);
 
 #endif
diff -ruN qmail-1.03-orig/subfdin.c qmail-1.03-ldap-20060201-orig/subfdin.c
--- qmail-1.03-orig/subfdin.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/subfdin.c	2006-02-25 11:00:56.000000000 +0100
@@ -2,10 +2,10 @@
 #include "substdio.h"
 #include "subfd.h"
 
-int subfd_read(fd,buf,len) int fd; char *buf; int len;
+int subfd_read(fd,buf,len) int fd; void *buf; int len;
 {
   if (substdio_flush(subfdout) == -1) return -1;
-  return read(fd,buf,len);
+  return subread(fd,buf,len);
 }
 
 char subfd_inbuf[SUBSTDIO_INSIZE];
diff -ruN qmail-1.03-orig/subfdins.c qmail-1.03-ldap-20060201-orig/subfdins.c
--- qmail-1.03-orig/subfdins.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/subfdins.c	2006-02-25 11:00:56.000000000 +0100
@@ -2,10 +2,10 @@
 #include "substdio.h"
 #include "subfd.h"
 
-int subfd_readsmall(fd,buf,len) int fd; char *buf; int len;
+int subfd_readsmall(fd,buf,len) int fd; void *buf; int len;
 {
   if (substdio_flush(subfdoutsmall) == -1) return -1;
-  return read(fd,buf,len);
+  return subread(fd,buf,len);
 }
 
 char subfd_inbufsmall[256];
diff -ruN qmail-1.03-orig/subfdout.c qmail-1.03-ldap-20060201-orig/subfdout.c
--- qmail-1.03-orig/subfdout.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/subfdout.c	2006-02-25 11:00:56.000000000 +0100
@@ -3,5 +3,5 @@
 #include "subfd.h"
 
 char subfd_outbuf[SUBSTDIO_OUTSIZE];
-static substdio it = SUBSTDIO_FDBUF(write,1,subfd_outbuf,SUBSTDIO_OUTSIZE);
+static substdio it = SUBSTDIO_FDBUF(subwrite,1,subfd_outbuf,SUBSTDIO_OUTSIZE);
 substdio *subfdout = &it;
diff -ruN qmail-1.03-orig/subfdouts.c qmail-1.03-ldap-20060201-orig/subfdouts.c
--- qmail-1.03-orig/subfdouts.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/subfdouts.c	2006-02-25 11:00:56.000000000 +0100
@@ -3,5 +3,5 @@
 #include "subfd.h"
 
 char subfd_outbufsmall[256];
-static substdio it = SUBSTDIO_FDBUF(write,1,subfd_outbufsmall,256);
+static substdio it = SUBSTDIO_FDBUF(subwrite,1,subfd_outbufsmall,256);
 substdio *subfdoutsmall = &it;
diff -ruN qmail-1.03-orig/subgetopt.c qmail-1.03-ldap-20060201-orig/subgetopt.c
--- qmail-1.03-orig/subgetopt.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/subgetopt.c	2006-02-25 11:00:56.000000000 +0100
@@ -28,10 +28,10 @@
 int sgopt(argc,argv,opts)
 int argc;
 char **argv;
-char *opts;
+const char *opts;
 {
   int c;
-  char *s;
+  const char *s;
 
   optarg = 0;
   if (!argv || (optind >= argc) || !argv[optind]) return optdone;
diff -ruN qmail-1.03-orig/subgetopt.h qmail-1.03-ldap-20060201-orig/subgetopt.h
--- qmail-1.03-orig/subgetopt.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/subgetopt.h	2006-02-25 11:00:56.000000000 +0100
@@ -13,7 +13,7 @@
 
 #define SUBGETOPTDONE -1
 
-extern int subgetopt();
+extern int subgetopt(int, char **, const char *);
 extern char *subgetoptarg;
 extern int subgetoptind;
 extern int subgetoptpos;
